maxrecursion = int(input())
calls = {}
context = None

command = input().split()
while command != ["."]:
    if not command:
        command = input().split()
        continue
        
    elif context is None:
        calls[command[1]] = []
        context = command[1]
        
    elif command[0] == "CALL":
        calls[context].append(command[1])
    
    else:
        context = None
    
    command = input().split()
    

answers = []
def run(function: str, stack: list):
    if len(stack) >= maxrecursion:
        return
    else:
        for f in calls[function]:
            answers.append(stack + [f])
            run(f, stack + [f])
    
run("MAIN", [])

print(len(answers))
for a in answers:
    print(*a)
    
    
"""
Во втором примере у жюри неверный вывод, а у этой программы - верный.

Второй пример:

3
FUNC A
CALL A
ENDFUNC
FUNC B
CALL A
ENDFUNC
FUNC C
ENDFUNC
FUNC MAIN
CALL A
CALL B
CALL C
ENDFUNC
.


Вывод этой программы на второй пример:
7
A
A A
A A A
B
B A
B A A
C


Ответ жюри на второй пример:
15
A
A A
A A A
A A B  <- Эта цепочка невозможна, потому что B не вызывается из A
A A C  <- Эта цепочка невозможна, потому что C не вызывается из A
A B    <- Эта цепочка невозможна, потому что B не вызывается из A
A B A  <- Эта цепочка невозможна, потому что B не вызывается из A
A B C  <- Эта цепочка невозможна, потому что B не вызывается из A, а C не вызывается из B
A C    <- Эта цепочка невозможна, потому что C не вызывается из A
B        
B A
B A A
B A C  <- Эта цепочка невозможна, потому что C не вызывается из A
B C    <- Эта цепочка невозможна, потому что C не вызывается из B
C


Объяснение настолько неправильного ответа жюри 
заключается в неправильной трактовке понятия стека и цепочки вызовов - в ответе она понимается, как последовательность всех вызовов
функций за все время работы программы вне зависимости от инициатора вызова, что, разумеется, не так: в противном случае либо значние N объвлялось бы
как максимальное количество вызванных фукнций (а не как глубина рекурсии), 
либо возможен был бы ответ "A A A B A A С", т. к. глубина вызовов здесь уходит не дальше заданного N.
"""