domain, *types = input().split()

html = [input()]
while html[-1] != '.':
    html.append(input())
html = html[:-1]


def parse_tag(tag: str) -> dict:
    tag = tag[1:-1].split()
    name = tag[0]
    params = {}
    for par in tag[1:]:
        if '=' in par:
            par_name, value = par.split('=')
            params[par_name] = value[1:-1]
    return {
        'name': name,
        'params': params
    }


def is_link(s: str):
    if s == '' or (s.count('.') + s.count('/') == 0):
        return False

    if '?' in s:
        s = s[:s.find('?')]
    if '#' in s:
        s = s[:s.find('#')]

    if domain in s:
        s = s[s.find(domain) + len(domain):]
    pages = s.split('/')

    if pages[0] != '' and '.' in pages[0]:
        return False

    file = pages[-1]
    file_type = file.split('.')[-1]
    if '.' in file and file_type not in types:
        return False

    return True


ans = []
for line in html:
    if line == '':
        continue

    n = len(line)

    tag_open = body = tag_close = ''

    for i in range(n):
        tag_open += line[i]
        if line[i] == '>':
            break

    for i in range(len(tag_open), n):
        if line[i] == '<':
            break
        body += line[i]

    for i in range(len(tag_open) + len(body), n):
        tag_close += line[i]

    parsed_tag = parse_tag(tag_open)
    for param, val in parsed_tag['params'].items():
        if is_link(val):
            ans.append(val)
    for text in body.split():
        if is_link(text):
            ans.append(text)


print(*ans, sep='\n')
