#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

bool ok_domen(string s, string name) {
	if (s.empty())
		return true;

	int n = s.size();
	for (int i = 0; i <= n - (int)name.size(); ++i) {
		if (s.substr(i, (int)name.size()) == name) {
			return true;
		}
	}
	return false;
}

bool check(string s, string name, set<string>& types) {
	//s.pop_back();
	//s.erase(s.begin());

	int n = s.size();
	int st = 0;
	for (int i = 0; i < n - 3; ++i) {
		if (s[i] == ':' && s[i + 1] == '/' && s[i + 2] == '/') {
			st = i + 2;
			break;
		}
	}

	string domen;
	int i = st + 1;
	while (i < n && s[i] != '/') {
		domen += s[i];
		++i;
	}

	if (!ok_domen(domen, name))
		return false;

	string type;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] == '.' || s[i] == '/') {
			type += s[i];
			break;
		}
		type += s[i];
	}

	reverse(type.begin(), type.end());
	if (type[0] == '/')
		return true;
	else {
		type.erase(type.begin());
		return types.find(type) != types.end();
	}
}

int main()
{
	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	string s;
	getline(cin, s);
	string name;

	int n = s.size();
	int i = 0;
	while (i < n && s[i] != ' ') {
		name += s[i];
		++i;
	}
	++i;
	s += ' ';

	set<string> types;
	string type;
	for (i; i <= n; ++i) {
		if (s[i] == ' ') {
			types.insert(type);
			type.clear();
		}
		else {
			type += s[i];
		}
	}

	string line;
	vector<string> ans;
	while (line != ".") {
		getline(cin, line);

		int n = line.size();
		int bal = 0;
		string a;
		for (int i = 0; i < n; ++i) {
			if (line[i] == '<')
				bal++;
			else if (line[i] == '>')
				bal--;

			if (line[i] == '=' && line[i + 1] == '"' && bal > 0) {
				i += 2;
				while (i < n && line[i] != '"' && line[i] != '?' && line[i] != '#') {
					a += line[i];
					++i;
				}
				if (check(a, name, types)) {
					ans.push_back(a);
				}
			}
		}
	}

	for (string i : ans) {
		cout << i << endl;
	}
}
